# timePriorityQueues.py

import queue
import priorityqueue
import time
import random

numberOfItems = 40000
myPriorityQueue = queue.LinkedPriorityQueue()
print "TIMING LINKED PRIORITY QUEUE"
start = time.clock()

for i in xrange(numberOfItems):
    item = random.randint(1,numberOfItems)
    myPriorityQueue.enqueue(item)
#end for
end = time.clock()
totalTime = end - start
print "Time to enqueue", numberOfItems, "items: total =", totalTime, "seconds."

start = time.clock()
for i in xrange(numberOfItems):
    value = myPriorityQueue.dequeue()
#end for
end = time.clock()
totalTime = end - start
print "Time to dequeue", numberOfItems, "items: total =", totalTime, "seconds."

print "="*35

myPriorityQueue = priorityqueue.HeapPriorityQueue()
print "TIMING HEAP PRIORITY QUEUE"
start = time.clock()
for i in xrange(numberOfItems):
    item = random.randint(1,numberOfItems)
    myPriorityQueue.enqueue(item)
#end for
end = time.clock()

totalTime = end - start
print "Time to enqueue", numberOfItems, "items: total =", totalTime, "seconds."

start = time.clock()
for i in xrange(numberOfItems):
    value = myPriorityQueue.dequeue()
#end for
end = time.clock()
totalTime = end - start
print "Time to dequeue", numberOfItems, "items: total =", totalTime, "seconds."

print "="*35
